import java.util.Arrays;

/* Task2: no slicing, no bullshit memcopy, parralelized merge */
public class Task2 {

  /* Create new sorted array by merging 2 smaller sorted arrays */
  private static void merge(int[] src, int[] dst, int idx1, int idx2, int end) {
		int mid  = idx2;
		int idx3 = idx1;
		while (idx1 < mid && idx2 < end) {
			if (src[idx1] < src[idx2])
        dst[idx3++] = src[idx1++];
			else
        dst[idx3++] = src[idx2++];
		}
		while (idx1 < mid) dst[idx3++] = src[idx1++];
		while (idx2 < end) dst[idx3++] = src[idx2++];
	}

  /* Recursive core, calls a sibling thread until max depth is reached */
  public static void kernel(int[] src, int[] dst, int start, int end, int depth) {

    /* Single thread sort if bottom has been reached (current node is a leaf) */
    if (depth == 0)
      Arrays.sort(src, start, end);

    /* Otherwise split task into two recursively */
    else {
      int mid = (start + end) / 2;
      Thread sibling = new Thread(() -> kernel(src, dst, mid, end, depth - 1));
      sibling.start();
      kernel(src, dst, start, mid, depth - 1);
      try {sibling.join();}
      catch (InterruptedException ie) {ie.printStackTrace();}
      if (depth % 2 == 0)
        merge(dst, src, start, mid, end);
      else
        merge(src, dst, start, mid, end);
    }

  }

  /* Creates a sorted version of any int array */
  public static int[] sort(int[] array) {

    /* Initialize variables */
    int[] src = array.clone();
    int[] dst = new int[array.length];

    /* Calculate optimal depth */
    int procNum   = Runtime.getRuntime().availableProcessors();
    int procDepth = (int) Math.ceil(Math.log(procNum) / Math.log(2));
    int arrDepth  = (int) (Math.log(array.length / 1000) / Math.log(2));
    int optDepth  = Math.max(0, Math.min(procDepth, arrDepth));

    /* Launch recursive core */
    kernel(src, dst, 0, src.length, optDepth);

    return optDepth % 2 == 0 ? src : dst;

  }
}
